const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const patient_messages = sequelize.define(
    'patient_messages',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      sender: {
        type: DataTypes.TEXT,
      },

      message: {
        type: DataTypes.TEXT,
      },

      read_status: {
        type: DataTypes.ENUM,

        values: ['unread', 'read'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  patient_messages.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.patient_messages.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.patient_messages.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.patient_messages.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return patient_messages;
};
